//+------------------------------------------------------------------+
//|                                                    ChgTF-All.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, zznbrm"
#property show_inputs

#import "user32.dll"
   int      PostMessageA(int hWnd,int Msg,int wParam,int lParam);
   int      GetWindow(int hWnd,int uCmd);
   int      GetParent(int hWnd);
#import

extern int eintTF = PERIOD_M5;                                                         //Variabile usata per settare il nuovo Timeframe
                   
int start()
{      
   bool blnContinue = true;   
   int intParent = GetParent( WindowHandle( Symbol(), Period() ) );                    //Ottiene l'Handle del grafico attualmente visualizzato (finestra genitore)
   int intChild = GetWindow( intParent, 0 );                                           //Ottine le Handle dei grafici non attualmente visualizzati (finestre figli)
   int intCmd; 
   
   switch( eintTF )
   {
      case PERIOD_M1:   intCmd = 33137;  break;                                        //Converte il valore del timeframe in uno nuovo che si po passare
      case PERIOD_M5:   intCmd = 33138;  break;                                        //tramite il comando PostMessageA
      case PERIOD_M15:  intCmd = 33139;  break;
      case PERIOD_M30:  intCmd = 33140;  break;
      case PERIOD_H1:   intCmd = 35400;  break;
      case PERIOD_H4:   intCmd = 33136;  break;
      case PERIOD_D1:   intCmd = 33134;  break;
      case PERIOD_W1:   intCmd = 33141;  break;
      case PERIOD_MN1:  intCmd = 33334;  break;
   }
   
   if ( intChild > 0 )   
   {
      if ( intChild != intParent )   PostMessageA( intChild, 0x0111, intCmd, 0 );      //0x0111 corrisponde alla variabile WM_COMMAND
   }
   else      blnContinue = false;                                                      //Se c' solo un grafico aperto non cerca per i figli
   
   while( blnContinue )
   {
      intChild = GetWindow( intChild, 2 );   
   
      if ( intChild > 0 )   
      { 
         if ( intChild != intParent )   PostMessageA( intChild, 0x0111, intCmd, 0 );   //Cambia il Timeframe alle finestre figli
      }
      else   blnContinue = false;   
   }
   
   // Now do the current window
   PostMessageA( intParent, 0x0111, intCmd, 0 );                                       //Cambia il Timeframe alla finestra genitore
}